
/*
  Liquid War 6 is a unique multiplayer wargame.
  Copyright (C)  2005, 2006, 2007, 2008  Christian Mauduit <ufoot@ufoot.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  

  Liquid War 6 homepage : http://www.gnu.org/software/liquidwar6/
  Contact author        : ufoot@ufoot.org
*/

#include "config.h"
#include "../cli.h"
#include "mod-udp-internal.h"

_udp_context_t *
_mod_udp_init ()
{
  _udp_context_t *udp_context = NULL;

  udp_context = (_udp_context_t *) LW6SYS_CALLOC (sizeof (_udp_context_t));
  if (!udp_context)
    {
      /*
       * No use to continue if this basic malloc fails...
       */
      exit (1);
    }

  lw6sys_log (LW6SYS_LOG_INFO, "cli-mod-udp", _("udp init"));

  return udp_context;
}

void
_mod_udp_quit (_udp_context_t * udp_context)
{
  lw6sys_log (LW6SYS_LOG_INFO, "cli-mod-udp", _("udp quit"));
  LW6SYS_FREE (udp_context);
}
